-- Flame
-- A small Homing Attack mockup.
-- Multi Target

addHook("ThinkFrame", do
	for p in players.iterate
		if not p.mo then return end
		local mo = p.mo
if p.mo and p.mo.scale and p.mo.friction and p.mo.movefactor and p.mo.pw_homingattack then //Do we have the Monitor Effect?? Good, off we go!!
		-- Always be on the lookout for a target if not homing.
		if not p.flhoming then
			mo.htable = L_Look4TargetTable(mo, 3*RING_DIST/4) -- Homing Table
		end
		
		-- Table count is larger than 0?
		if (#mo.htable > 0) then
			for i = 1, #mo.htable do -- Lets go through the table!
				if not (mo.htable[i] and mo.htable[i].valid) then continue end
				if not mo.htable[i].health then continue end -- Enemy in Homing Table has no health.

				if (p == consoleplayer) then -- Only show the marker for YOU
					P_SpawnLockOn(p, mo.htable[i], S_LOCKON1)
				end
			end
		end

		-- Homing Action
		p.flhoming = $ or 0
		if (p.flhoming > 0)
			
			-- Decrease tic timer by one
			p.flhoming = $ - 1
			
			-- Homing but prematurely hit the floor?
			if P_IsObjectOnGround(mo) 
			or (mo.eflags & MFE_JUSTHITFLOOR) 
			or (mo.z <= mo.floorz) then 
				p.flhoming = 0 -- I guess you shouldn't be homing anymore.
			end
			
			-- Home in on the first 'seen' target
			if mo.htable[1] and mo.htable[1].valid
			and (mo.htable[1].health > 0) then
				local target = mo.htable[1]
				L_HomingAttackXY(mo, target) -- Home in
				P_SetObjectMomZ(mo, -3*gravity, true)
				P_SpawnGhostMobj(mo) -- Spawn a ghost trail behind you
			elseif (mo.htable[2] and mo.htable[2].valid) then -- Enemy in homing table no longer valid, but there's still an enemy in the table?
				-- Move on to the next target
				table.remove(mo.htable, 1) -- Shift the table up by one
				local target = mo.htable[1]
				p.flhoming = 5*TICRATE -- Reset the homing timer
				mo.momz = $>>1 -- Reset z momentum
				local dist = abs(FixedHypot(target.x - mo.x, target.y - mo.y))/25
				P_SetObjectMomZ(mo, dist, false) -- Bounce!
				p.flhoming = 5*TICRATE
			else
				mo.momz = $>>1
				p.flhoming = 0
			end
		end
		if (homingattacker[p.mo.skin]) or (p.charability == CA_HOMINGTHOK)
		p.mo.pw_homingattack = 0
		CONS_Printf(p, "You cannot cheat this effect by changing characters or abilities!!") //Na ah, you cheeky bastard!
		S_StartSound(p.mo, sfx_lose)
		return end
		end
	end
end)

addHook("PlayerThink", function(p)
	if not p.mo then return end
	local mo = p.mo
	if p.mo and p.mo.scale and p.mo.friction and p.mo.movefactor and p.mo.pw_homingattack then //Do we have the Monitor Effect?? Good, off we go!!
	if p.mo.pw_homingattack > 1
		p.mo.pw_homingattack = $ - 1
	elseif p.mo.pw_homingattack == 1
		p.mo.pw_homingattack = 0
		p.flhoming = 0
	end
	if (p.cmd.buttons & BT_CUSTOM1) and not (P_IsObjectOnGround(mo) or P_PlayerInPain(p) or mo.health == 0)

	
	if (#mo.htable > 0) then -- Not a valid tracer from the previous tic	
		if p.flhoming then return true end -- Not already homing in on a target
		-- We actually don't want the player to do anything if they're already homing
		-- Homing trigger
		local target = mo.htable[1]
		if (target.health <= 0) then return true end -- Object is dying, hold off for a sec
		if not (mo.state == S_PLAY_ROLL) then mo.state = S_PLAY_ROLL 
		p.pflags = $|PF_THOKKED|PF_JUMPED|PF_JUMPSTASIS &~(PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING) end
		S_StartSoundAtVolume(mo, sfx_s3k47, 170)
		S_StartSoundAtVolume(mo, sfx_zoom, 140)
		local dist = abs(FixedHypot(target.x - mo.x, target.y - mo.y))/20
		P_SetObjectMomZ(mo, dist, false)
		
		-- Start homing in!
		p.flhoming = 5*TICRATE -- Only home in for 2 seconds before getting 'tired'
		--p.pflags = $ | PF_THOKKED
		return true
	else
		return false
	end
	end
	end
end)

local function hud_extraicon(v,player)
	if not player.mo return end //Inspired from ESP Powers, we need a HUD Display dont you think??
	if not (CV_FindVar("powerupdisplay").value == 2 or (CV_FindVar("powerupdisplay").value == 1 and R_PointToDist(player.mo.x, player.mo.y) < FRACUNIT))
		return
	end

	local x = hudinfo[HUD_POWERUPS].x*FRACUNIT
	local y = hudinfo[HUD_POWERUPS].y*FRACUNIT
	local f = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER
	local sep = 20*FRACUNIT

	if player.pflags & PF_FINISHED and CV_FindVar("exitmove").value and multiplayer
		x = $ - sep
	end

	if (player.powers[pw_shield] & SH_NOSTACK) or (player.powers[pw_shield] & SH_STACK)
		x = $ - sep
	end

	if player.gotflag
		x = $ - sep
	end
	if player.powers[pw_invulnerability] or player.powers[pw_flashing]
		x = $ - sep
	end
	if player.powers[pw_sneakers]
		x = $ - sep
	end
	if player.powers[pw_gravityboots]
		x = $ - sep
	end

		if player.mo.pw_homingattack
		if player.mo.pw_homingattack > 3*TICRATE or (player.mo.pw_homingattack and leveltime % 2)
			v.drawScaled(x,y,FRACUNIT/2,v.cachePatch("HOATICON"),f)
			v.drawString(x+16*FRACUNIT,y+8*FRACUNIT,tostring(player.mo.pw_homingattack/TICRATE),f,"thin-fixed-right")
		end
		x = $ - sep
	end
end

hud.add(hud_extraicon)